; 
    include \masm32\include\masm32rt.inc

    NTCompressFile   PROTO :DWORD,:DWORD,:DWORD
    NTDecompressFile PROTO :DWORD,:DWORD,:DWORD
    filecmp          PROTO :DWORD,:DWORD

    ; ----------------------------------
    ; These from ntstatus.h in the PSDK
    ; ----------------------------------

    STATUS_SUCCESS                  equ 0
    STATUS_UNSUPPORTED_COMPRESSION  equ 0C000025Fh
    STATUS_INVALID_PARAMETER        equ 0C000000Dh
    STATUS_BUFFER_ALL_ZEROS         equ 000000117h
    STATUS_NOT_SUPPORTED            equ 0C00000BBh
    STATUS_BUFFER_TOO_SMALL         equ 0C0000023h
    STATUS_BAD_COMPRESSION_BUFFER   equ 0C0000242h

; 
    .data
      ntdllRtlGetCompressionWorkSpaceSize  dd 0
      ntdllRtlCompressBuffer               dd 0
      ntdllRtlDecompressBuffer             dd 0
    .code
; 
start:
; 

    LoadProcAddress "ntdll.dll","RtlGetCompressionWorkSpaceSize"
    mov ntdllRtlGetCompressionWorkSpaceSize, eax
    LoadProcAddress "ntdll.dll","RtlCompressBuffer"
    mov ntdllRtlCompressBuffer, eax
    LoadProcAddress "ntdll.dll","RtlDecompressBuffer"
    mov ntdllRtlDecompressBuffer, eax

    RtlGetCompressionWorkSpaceSize DDPROTO(ntdllRtlGetCompressionWorkSpaceSize, 3)
    RtlCompressBuffer DDPROTO(ntdllRtlCompressBuffer, 8)
    RtlDecompressBuffer DDPROTO(ntdllRtlDecompressBuffer, 6)

    print "compressing windows.inc to windows.inc.ntc (standard compression):",13,10
    print "(zipped size = 232448 bytes, zipped ratio = 79.4%)",13,10
    invoke NTCompressFile,chr$("\masm32\include\windows.inc"),
                          chr$("windows.inc.ntc"),0

    print "decompressing windows.inc.ntc to windows.inc.ntd:",13,10
    invoke NTDecompressFile,chr$("windows.inc.ntc"),chr$("windows.inc.ntd"),0

    print "comparing windows.inc to windows.inc.ntd: "
    invoke filecmp,chr$("\masm32\include\windows.inc"),chr$("windows.inc.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10
    
    print "compressing windows.inc to windows.inc.ntc (maximum compression):",13,10
    print "(zipped size = 232448 bytes, zipped ratio = 79.4%)",13,10
    invoke NTCompressFile,chr$("\masm32\include\windows.inc"),
                          chr$("windows.inc.ntc"),
                          COMPRESSION_ENGINE_MAXIMUM

    print "decompressing windows.inc.ntc to windows.inc.ntd:",13,10
    invoke NTDecompressFile,chr$("windows.inc.ntc"),
                            chr$("windows.inc.ntd"),0

    print "comparing windows.inc to windows.inc.ntd: "
    invoke filecmp,chr$("\masm32\include\windows.inc"),chr$("windows.inc.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10

    print "compressing masm32.bmp to masm32.bmp.ntc (standard compression):",13,10
    print "(zipped size = 34834 bytes, zipped ratio = 98.5%)",13,10
    invoke NTCompressFile,chr$("masm32.bmp"),chr$("masm32.bmp.ntc"),0

    print "decompressing masm32.bmp.ntc to masm32.bmp.ntd:",13,10
    invoke NTDecompressFile,chr$("masm32.bmp.ntc"),chr$("masm32.bmp.ntd"),0

    print "comparing masm32.bmp to masm32.bmp.ntd: "
    invoke filecmp,chr$("masm32.bmp"),chr$("masm32.bmp.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10

    print "compressing masm32.bmp to masm32.bmp.ntc (maximum compression):",13,10
    print "(zipped size = 34834 bytes, zipped ratio = 98.5%)",13,10
    invoke NTCompressFile,chr$("masm32.bmp"),chr$("masm32.bmp.ntc"),
                          COMPRESSION_ENGINE_MAXIMUM

    print "decompressing masm32.bmp.ntc to masm32.bmp.ntd:",13,10
    invoke NTDecompressFile,chr$("masm32.bmp.ntc"),chr$("masm32.bmp.ntd"),0

    print "comparing masm32.bmp to masm32.bmp.ntd: "
    invoke filecmp,chr$("masm32.bmp"),chr$("masm32.bmp.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10

    print "compressing xfile.bin to xfile.bin.ntc (standard compression):",13,10
    print "(zipped size = 9719 bytes, zipped ratio = 99.9%)",13,10
    invoke NTCompressFile, chr$("xfile.bin"),chr$("xfile.bin.ntc"),0

    print "decompressing xfile.bin.ntc to xfile.bin.ntd:",13,10
    invoke NTDecompressFile,chr$("xfile.bin.ntc"),chr$("xfile.bin.ntd"),
                            10000000

    print "comparing xfile.bin to xfile.bin.ntd: "
    invoke filecmp,chr$("xfile.bin"),chr$("xfile.bin.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10

    print "compressing xfile.bin to xfile.bin.ntc (maximum compression):",13,10
    print "(zipped size = 9719 bytes, zipped ratio = 99.9%)",13,10
    invoke NTCompressFile,chr$("xfile.bin"),chr$("xfile.bin.ntc"),
                          COMPRESSION_ENGINE_MAXIMUM

    print "decompressing xfile.bin.ntc to xfile.bin.ntd:",13,10
    invoke NTDecompressFile,chr$("xfile.bin.ntc"),chr$("xfile.bin.ntd"),
                            10000000

    print "comparing xfile.bin to xfile.bin.ntd: "
    invoke filecmp,chr$("xfile.bin"),chr$("xfile.bin.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to continue...",13,10

    print "compressing xfile.zip to xfile.zip.ntc (normal compression):",13,10
    invoke NTCompressFile,chr$("xfile.zip"),chr$("xfile.zip.ntc"),0

    print "decompressing xfile.zip.ntc to xfile.zip.ntd:",13,10
    invoke NTDecompressFile,chr$("xfile.zip.ntc"),chr$("xfile.zip.ntd"),10000

    print "comparing xfile.zip to xfile.zip.ntd: "
    invoke filecmp,chr$("xfile.zip"),chr$("xfile.zip.ntd")
    .IF eax == 1
      print "OK",13,10,13,10
    .ELSE
      print "error",13,10,13,10
    .ENDIF

    inkey "Press any key to exit..."
    exit

; 
; This proc compresses the specified source file using the NTDLL
; RtlCompressBuffer function and writes the result to the specified
; destination file. If there is a problem opening either of the files,
; it displays an error message and returns INVALID_HANDLE_VALUE (-1).
; Otherwise, it displays the relevant statistics and returns whatever
; the NTDLL RtlCompressBuffer function returned.
; 

NTCompressFile proc lpUncompressedFileName:DWORD,
                    lpCompressedFileName:DWORD,
                    engine:DWORD

    LOCAL hFileU:DWORD,lofU:DWORD,hMMFU:DWORD,lpMemU:DWORD
    LOCAL hFileC:DWORD,lofC:DWORD,hMMFC:DWORD,lpMemC:DWORD
    LOCAL workSpaceSize:DWORD,lpWorkSpace:DWORD
    LOCAL compressionFormatAndEngine:DWORD
    LOCAL junk          :DWORD
    LOCAL finalSize     :DWORD
    LOCAL startTicks    :DWORD
    LOCAL ratio         :REAL8

    mov startTicks, rv(GetTickCount)

    invoke CreateFile,lpUncompressedFileName,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFileU, eax
    .IF eax == INVALID_HANDLE_VALUE
        push eax
        print "Error opening source file",13,10
        pop eax
        jmp @F
    .ENDIF

    invoke CreateFile,lpCompressedFileName,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFileC, eax
    .IF eax == INVALID_HANDLE_VALUE
        push eax
        invoke CloseHandle,hFileU
        print "Error opening destination file",13,10
        pop eax
        jmp @F
    .ENDIF

    mov hMMFU, rv(CreateFileMapping,hFileU,NULL,PAGE_READWRITE,0,0,NULL)

    mov lpMemU, rv(MapViewOfFile,hMMFU,FILE_MAP_WRITE,0,0,0)

    mov lofU, rv(GetFileSize,hFileU,NULL)

    ; ---------------------------
    ; Allow lofU * 1.25 for lofC
    ; ---------------------------

    mov eax, lofU
    shr eax, 2
    add eax, lofU
    mov lofC, eax

    mov hMMFC, rv(CreateFileMapping,hFileC,NULL,PAGE_READWRITE,0,lofC,NULL)

    mov lpMemC, rv(MapViewOfFile,hMMFC,FILE_MAP_WRITE,0,0,0)

    mov edx, engine
    or  edx, COMPRESSION_FORMAT_LZNT1
    push edx
    invoke RtlGetCompressionWorkSpaceSize,edx,
                                          ADDR workSpaceSize,
                                          ADDR junk
    mov lpWorkSpace, rv(HeapAlloc,rv(GetProcessHeap),0,workSpaceSize)
    pop edx
    invoke RtlCompressBuffer,edx,
                             lpMemU,
                             lofU,
                             lpMemC,
                             lofC,
                             0,
                             ADDR finalSize,
                             lpWorkSpace
    push eax

    invoke UnmapViewOfFile,lpMemU
    invoke UnmapViewOfFile,lpMemC
    invoke CloseHandle,hMMFU
    invoke CloseHandle,hMMFC
    invoke CloseHandle,hFileU

    invoke HeapFree,rv(GetProcessHeap),0,lpWorkSpace
        
    invoke SetFilePointer,hFileC,finalSize,0,0
    invoke SetEndOfFile,hFileC
    invoke CloseHandle,hFileC

    invoke GetTickCount
    push  eax    
    
    print "uncompressed size = "
    print ustr$(lofU)," bytes",13,10
    print "compressed size = "
    print ustr$(finalSize)," bytes",13,10

    fild finalSize
    fild lofU
    fdiv    
    fld8 100.0
    fmul
    fld8 100.0
    fsubr
    fstp ratio
    invoke crt_printf,chr$("ratio = %.1f%%%c"),ratio,10

    print "elapsed time = "
    pop eax
    sub eax, startTicks
    print ustr$(eax),"ms",13,10,13,10

    pop eax
  @@:    
    ret

NTCompressFile endp

; 
; This proc decompresses the specified source file using the NTDLL
; RtlDecompressBuffer function and writes the result to the specified
; destination file. If there is a problem opening either of the files,
; it displays an error message and returns INVALID_HANDLE_VALUE (-1).
; Otherwise, it displays the relevant statistics and returns whatever
; the NTDLL RtlDecompressBuffer function returned.
; 

NTDecompressFile proc lpCompressedFileName:DWORD,
                      lpUncompressedFileName:DWORD,
                      bufferSize:DWORD

    LOCAL hFileC:DWORD,lofC:DWORD,hMMFC:DWORD,lpMemC:DWORD
    LOCAL hFileU:DWORD,lofU:DWORD,hMMFU:DWORD,lpMemU:DWORD
    LOCAL finalSize   :DWORD
    LOCAL startTicks  :DWORD

    mov startTicks, rv(GetTickCount)

    invoke CreateFile,lpCompressedFileName,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFileC, eax
    .IF eax == INVALID_HANDLE_VALUE
        push eax
        print "Error opening source file",13,10
        pop eax
        jmp @F
    .ENDIF

    invoke CreateFile,lpUncompressedFileName,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFileU, eax
    .IF eax == INVALID_HANDLE_VALUE
        push eax
        invoke CloseHandle,hFileC
        print "Error opening destination file",13,10
        pop eax
        jmp @F
    .ENDIF

    mov hMMFC, rv(CreateFileMapping,hFileC,NULL,PAGE_READWRITE,0,0,NULL)

    mov lpMemC, rv(MapViewOfFile,hMMFC,FILE_MAP_WRITE,0,0,0)

    mov lofC, rv(GetFileSize,hFileC,NULL)

    mov eax, bufferSize
    .IF eax == 0

      ; -----------------------
      ; Allow for ~93.8% ratio
      ; -----------------------

      mov eax, lofC
      shl eax, 4
    .ENDIF
    mov lofU, eax

    mov hMMFU, rv(CreateFileMapping,hFileU,NULL,PAGE_READWRITE,0,lofU,NULL)

    mov lpMemU, rv(MapViewOfFile,hMMFU,FILE_MAP_WRITE,0,0,0)

    invoke RtlDecompressBuffer,COMPRESSION_FORMAT_LZNT1,
                               lpMemU,
                               lofU,
                               lpMemC,
                               lofC,
                               ADDR finalSize
    push eax

    invoke UnmapViewOfFile,lpMemC
    invoke UnmapViewOfFile,lpMemU
        
    invoke CloseHandle,hMMFC
    invoke CloseHandle,hMMFU
    invoke CloseHandle,hFileC
    invoke SetFilePointer,hFileU,finalSize,0,0
    invoke SetEndOfFile,hFileU
    invoke CloseHandle,hFileU

    invoke GetTickCount
    push  eax
    
    print "compressed size = "
    print ustr$(lofC)," bytes",13,10
    print "uncompressed size = "
    print ustr$(finalSize)," bytes",13,10

    print "elapsed time = "
    pop eax
    sub eax, startTicks
    print ustr$(eax),"ms",13,10,13,10

    pop eax
  @@:
    ret

NTDecompressFile endp

; 
; This proc performs a binary comparison of two files, returning 0
; if the files are different, 1 if the files are byte identical, or
; INVALID_HANDLE_VALUE (-1) if there is a problem opening either of
; the files.
; 

filecmp proc uses ebx lpszFile1:DWORD, lpszFile2:DWORD

    LOCAL hFile1:DWORD,lof1:DWORD,hMMF1:DWORD,lpMem1:DWORD
    LOCAL hFile2:DWORD,lof2:DWORD,hMMF2:DWORD,lpMem2:DWORD

    invoke CreateFile,lpszFile1,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile1, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    ret

  @@:
    invoke CreateFile,lpszFile2,
                      GENERIC_READ or GENERIC_WRITE,
                      FILE_SHARE_READ or FILE_SHARE_WRITE,
                      NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL,
                      NULL
    mov hFile2, eax
    cmp eax, INVALID_HANDLE_VALUE
    jne @F
    push eax
    invoke CloseHandle,hFile1
    pop eax
    ret

  @@:
    invoke GetFileSize,hFile1,NULL
    mov lof1, eax
    invoke GetFileSize,hFile2,NULL
    mov lof2, eax

    xor ebx, ebx
    mov ecx, lof1
    cmp ecx, lof2
    jne @F

    mov hMMF1, rv(CreateFileMapping,hFile1,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem1, rv(MapViewOfFile,hMMF1,FILE_MAP_WRITE,0,0,0)
    mov hMMF2, rv(CreateFileMapping,hFile2,NULL,PAGE_READWRITE,0,0,NULL)
    mov lpMem2, rv(MapViewOfFile,hMMF2,FILE_MAP_WRITE,0,0,0)

    invoke cmpmem,lpMem1,lpMem2,lof1
    mov ebx, eax

    invoke UnmapViewOfFile,lpMem1
    invoke UnmapViewOfFile,lpMem2
    invoke CloseHandle,hMMF1
    invoke CloseHandle,hMMF2

  @@:    
    invoke CloseHandle,hFile1
    invoke CloseHandle,hFile2

    mov eax, ebx
    ret

filecmp endp

; 
end start

; ---------------------------------------------------
; These derived from various sources on the Internet
; ---------------------------------------------------

NTSTATUS RtlGetCompressionWorkSpaceSize(
  DWORD   dwCompressionFormatAndEngine,
  LPDWORD lpcbCompressBufferWorkSpaceSize,
  LPDWORD lpcbCompressFragmentWorkSpaceSize
);

NTSTATUS RtlCompressBuffer(
  DWORD   dwCompressionFormatAndEngine,
  LPCVOID lpUnCompressedBuffer,
  DWORD   dwcbUnCompressedBufferSize,
  LPCVOID lpCompressedBuffer,
  DWORD   dwcbCompressedBufferSize,
  DWORD   dwcbUnCompressedChunkSize,
  LPDWORD lpdwFinalCompressedSize,
  LPCVOID lpCompressBufferWorkspace
);

NTSTATUS RtlDecompressBuffer(
  DWORD   dwCompressionFormat,
  LPCVOID lpUnCompressedBuffer,
  DWORD   dwUnCompressedBufferSize,
  LPCVOID lpCompressedBuffer,
  DWORD   dwCompressedBufferSize,
  LPDWORD lpdwFinalDecompressedSize
);
